osl::effect_action::Promote< Action > Class Template Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Member Functions | Private Attributes | List of all members
osl::effect_action::Promote< Action > Class Template Reference

SimplePromote と違って， unknownMove を呼ぶ More...

`#include <promote.h>`

Collaboration diagram for osl::effect_action::Promote< Action >:
[legend]

## Public Member Functions
| Promote (const NumEffectState &s, Action &a)
template<Player P, Ptype Type>
void | doActionPtype (Piece p1, Square to)
template<Player P>
void | doAction (Piece p1, Square to)
bool | done () const

## Private Member Functions
| BOOST_CLASS_REQUIRE (Action, osl::move_action, Concept)

## Private Attributes
const NumEffectState & | state
Action & | ac

## Detailed Description

### template<class Action>
class osl::effect_action::Promote< Action >

SimplePromote と違って， unknownMove を呼ぶ

Definition at line 12 of file promote.h.

## Constructor & Destructor Documentation

template<class Action>

osl::effect_action::Promote< Action >::Promote | ( | const NumEffectState & | s,
|  | Action & | a
| ) |  |
| inline

Definition at line 19 of file promote.h.

## Member Function Documentation

template<class Action>

osl::effect_action::Promote< Action >::BOOST_CLASS_REQUIRE | ( | Action | ,
|  | osl::move_action | ,
|  | Concept |
| ) |  |
| private

template<class Action>
template<Player P>

void osl::effect_action::Promote< Action >::doAction | ( | Piece | p1,
|  | Square | to
| ) |  |
| inline

Definition at line 32 of file promote.h.

References osl::effect_action::Promote< Action >::ac, osl::Square::canPromote(), osl::Piece::isPromoted(), osl::promote(), osl::Piece::ptype(), osl::Piece::square(), and osl::effect_action::Promote< Action >::state.

template<class Action>
template<Player P, Ptype Type>

void osl::effect_action::Promote< Action >::doActionPtype | ( | Piece | p1,
|  | Square | to
| ) |  |
| inline

Definition at line 24 of file promote.h.

References osl::effect_action::Promote< Action >::ac, osl::Square::canPromote(), osl::Piece::isPromoted(), osl::promote(), osl::Piece::square(), and osl::effect_action::Promote< Action >::state.

template<class Action>

bool osl::effect_action::Promote< Action >::done | ( | ) |  | const
| inline

Definition at line 40 of file promote.h.

## Member Data Documentation

template<class Action>

Action& osl::effect_action::Promote< Action >::ac
| private

Definition at line 17 of file promote.h.

Referenced by osl::effect_action::Promote< Action >::doAction(), and osl::effect_action::Promote< Action >::doActionPtype().

template<class Action>

const NumEffectState& osl::effect_action::Promote< Action >::state
| private

Definition at line 16 of file promote.h.

Referenced by osl::effect_action::Promote< Action >::doAction(), osl::effect_action::Promote< Action >::doActionPtype(), and osl::move_generator::Promote< P, NoCapture >::generatePtype().

The documentation for this class was generated from the following file:

- promote.h